﻿Public Class Form1
    Private Sub btnForm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnForm.Click
        ShowControlImage(Me)
    End Sub

    Private Sub btnClientArea_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClientArea.Click
        Using bm As Bitmap = GetFormImageWithoutBorders(Me)
            Dim frm As New SampleForm()
            frm.BackgroundImage = bm
            frm.ClientSize = bm.Size
            frm.ShowDialog()
        End Using
    End Sub

    Private Sub btnGroupBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGroupBox.Click
        ShowControlImage(groupBox1)
    End Sub

    Private Sub btnPage1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPage1.Click
        Dim selected As Integer = tabControl1.SelectedIndex
        tabControl1.SelectedIndex = 0

        ShowControlImage(tabPage1)

        tabControl1.SelectedIndex = selected
    End Sub

    Private Sub btnPage2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPage2.Click
        Dim selected As Integer = tabControl1.SelectedIndex
        tabControl1.SelectedIndex = 1

        ShowControlImage(tabPage2)

        tabControl1.SelectedIndex = selected
    End Sub

    ' Display the control's image in a new form.
    Private Sub ShowControlImage(ByVal ctl As Control)
        Using bm As Bitmap = GetControlImage(ctl)
            Dim frm As New SampleForm()
            frm.BackgroundImage = bm
            frm.ClientSize = bm.Size
            frm.ShowDialog()
        End Using
    End Sub

    ' Return a Bitmap holding an image of the control.
    Private Function GetControlImage(ByVal ctl As Control) As Bitmap
        Dim bm As New Bitmap(ctl.Width, ctl.Height)
        ctl.DrawToBitmap(bm, New Rectangle(0, 0, ctl.Width, ctl.Height))
        Return bm
    End Function

    ' Return the form's image without its borders and decorations.
    Private Function GetFormImageWithoutBorders(ByVal frm As Form) As Bitmap
        ' Get the form's whole image.
        Using whole_form As Bitmap = GetControlImage(frm)
            ' See how far the form's upper left corner is
            ' from the upper left corner of its client area.
            Dim origin As Point = frm.PointToScreen(New Point(0, 0))
            Dim dx As Integer = origin.X - frm.Left
            Dim dy As Integer = origin.Y - frm.Top

            ' Copy the client area into a new Bitmap.
            Dim wid As Integer = frm.ClientSize.Width
            Dim hgt As Integer = frm.ClientSize.Height
            Dim bm As New Bitmap(wid, hgt)
            Using gr As Graphics = Graphics.FromImage(bm)
                gr.DrawImage(whole_form, 0, 0, _
                    New Rectangle(dx, dy, wid, hgt), _
                    GraphicsUnit.Pixel)
            End Using
            Return bm
        End Using
    End Function
End Class
